Index: trunk/AGRIF/LIB/fortran.y
===================================================================
--- trunk/AGRIF/LIB/fortran.y	(revision 530)
+++ trunk/AGRIF/LIB/fortran.y	(revision 663)
@@ -1371,17 +1338,24 @@
       | TOK_OUT     {sprintf($$,"out");}
       | TOK_INOUT   {sprintf($$,"inout");}
-      ; 
-access_spec: TOK_PUBLIC 
-                   {PublicDeclare = 1;} 
-      | TOK_PRIVATE 
-                   {PrivateDeclare = 1;} 
-      ;
-dims:              {if ( created_dimensionlist == 1 ) $$=(listdim *)NULL;}
-      | '(' dimlist ')'  
-                   {if ( created_dimensionlist == 1 ) $$=$2;}
-      ;
-dimlist:   dim     {if ( created_dimensionlist == 1 ) $$=insertdim(NULL,$1);}
-      | dimlist ',' dim 
-                   {if ( created_dimensionlist == 1 ) $$=insertdim($1,$3);}
+      ;
+access_spec: TOK_PUBLIC
+                   {PublicDeclare = 1;}
+      | TOK_PRIVATE
+                   {PrivateDeclare = 1;}
+      ;
+dims:              {if ( created_dimensionlist == 1 )
+                       {
+                           $$=(listdim *)NULL;
+                       }
+                   }
+      | '(' dimlist ')'
+                   {if ( created_dimensionlist == 1 ||
+                         agrif_parentcall      == 1 ) $$=$2;}
+      ;
+dimlist:   dim     {if ( created_dimensionlist == 1 ||
+                         agrif_parentcall      == 1 ) $$=insertdim(NULL,$1);}
+      | dimlist ',' dim
+                   {if ( couldaddvariable == 1 )
+                         if ( created_dimensionlist == 1 ) $$=insertdim($1,$3);}
       ;
 dim:ubound         {strcpy($$.first,"1");strcpy($$.last,$1);}
@@ -1395,13 +1369,14 @@
       | expr       {strcpy($$,$1);}
       ;
-expr:  uexpr       {strcpy($$,$1);}
-      | '(' expr ')' 
-                   {sprintf($$,"(%s)",$2);}
-      | complex_const 
-                   {strcpy($$,$1);}
+expr:  uexpr       {if ( couldaddvariable == 1 ) strcpy($$,$1);}
+      | '(' expr ')'
+                   {if ( couldaddvariable == 1 ) sprintf($$,"(%s)",$2);}
+      | complex_const
+                   {if ( couldaddvariable == 1 ) strcpy($$,$1);}
       | predefinedfunction
-      ;
-      
-predefinedfunction : TOK_SUM minmaxlist ')' 
+                   {if ( couldaddvariable == 1 ) strcpy($$,$1);}
+      ;
+
+predefinedfunction : TOK_SUM minmaxlist ')'
                    {sprintf($$,"SUM(%s)",$2);}
       | TOK_MAX minmaxlist ')'
@@ -1422,7 +1397,7 @@
                    {sprintf($$,"REAL(%s)",$3);}
       | TOK_INT '(' expr ')'
-                   {sprintf($$,"INT(%s)",$3);}                   
+                   {sprintf($$,"INT(%s)",$3);}
       | TOK_NINT '(' expr ')'
-                   {sprintf($$,"NINT(%s)",$3);}                   
+                   {sprintf($$,"NINT(%s)",$3);}
       | TOK_FLOAT '(' expr ')'
                    {sprintf($$,"FLOAT(%s)",$3);}
@@ -1459,80 +1434,81 @@
       ;
 minmaxlist : expr {strcpy($$,$1);}
-      | minmaxlist ',' expr 
-                   {strcpy($$,$1);strcat($$,",");strcat($$,$3);}
-      ;
-uexpr:  lhs        {strcpy($$,$1);} 
-      | simple_const 
-                   {strcpy($$,$1);} 
-      | vec 
-                   {strcpy($$,$1);} 
+      | minmaxlist ',' expr
+                   {if ( couldaddvariable == 1 )
+                   { strcpy($$,$1);strcat($$,",");strcat($$,$3);}}
+      ;
+uexpr:  lhs        {if ( couldaddvariable == 1 ) strcpy($$,$1);}
+      | simple_const
+                   {if ( couldaddvariable == 1 ) strcpy($$,$1);}
+      | vec
+                   {if ( couldaddvariable == 1 ) strcpy($$,$1);}
       | expr operation
-                   {sprintf($$,"%s%s",$1,$2);}
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s%s",$1,$2);}
       | signe expr %prec '* ' 
-                   {sprintf($$,"%s%s",$1,$2);}
-      | TOK_NOT expr 
-                   {sprintf($$,"%s%s",$1,$2);}
-      ;
-signe : '+'        {strcpy($$,"+");}
-      | '-'        {strcpy($$,"-");}
-      ;
-operation : '+' expr %prec '+' 
-                   {sprintf($$,"+%s",$2);}
-      |  '-' expr %prec '+' 
-                   {sprintf($$,"-%s",$2);}
-      |  '*' expr 
-                   {sprintf($$,"*%s",$2);}
-      |  TOK_DASTER expr 
-                   {sprintf($$,"%s%s",$1,$2);}
-      |  TOK_EQ expr %prec TOK_EQ 
-                   {sprintf($$,"%s%s",$1,$2);}
-      |  TOK_GT expr %prec TOK_EQ 
-                   {sprintf($$,"%s%s",$1,$2);}
-      |  '>' expr %prec TOK_EQ 
-                   {sprintf($$," > %s",$2);}
-      |  TOK_LT expr %prec TOK_EQ 
-                   {sprintf($$,"%s%s",$1,$2);}
-      |  '<' expr %prec TOK_EQ 
-                   {sprintf($$," < %s",$2);}
-      |  TOK_GE expr %prec TOK_EQ 
-                   {sprintf($$,"%s%s",$1,$2);}
-      |  '>''=' expr %prec TOK_EQ 
-                   {sprintf($$," >= %s",$3);}
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s%s",$1,$2);}
+      | TOK_NOT expr
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s%s",$1,$2);}
+      ;
+signe : '+'        {if ( couldaddvariable == 1 ) strcpy($$,"+");}
+      | '-'        {if ( couldaddvariable == 1 ) strcpy($$,"-");}
+      ;
+operation : '+' expr %prec '+'
+                   {if ( couldaddvariable == 1 ) sprintf($$,"+%s",$2);}
+      |  '-' expr %prec '+'
+                   {if ( couldaddvariable == 1 ) sprintf($$,"-%s",$2);}
+      |  '*' expr
+                   {if ( couldaddvariable == 1 ) sprintf($$,"*%s",$2);}
+      |  TOK_DASTER expr
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s%s",$1,$2);}
+      |  TOK_EQ expr %prec TOK_EQ
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s%s",$1,$2);}
+      |  TOK_GT expr %prec TOK_EQ
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s%s",$1,$2);}
+      |  '>' expr %prec TOK_EQ
+                   {if ( couldaddvariable == 1 ) sprintf($$," > %s",$2);}
+      |  TOK_LT expr %prec TOK_EQ
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s%s",$1,$2);}
+      |  '<' expr %prec TOK_EQ
+                   {if ( couldaddvariable == 1 ) sprintf($$," < %s",$2);}
+      |  TOK_GE expr %prec TOK_EQ
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s%s",$1,$2);}
+      |  '>''=' expr %prec TOK_EQ
+                   {if ( couldaddvariable == 1 ) sprintf($$," >= %s",$3);}
       |  TOK_LE expr %prec TOK_EQ
-                   {sprintf($$,"%s%s",$1,$2);}
-      |  '<''=' expr %prec TOK_EQ 
-                   {sprintf($$," <= %s",$3);}
-      |  TOK_NE expr %prec TOK_EQ 
-                   {sprintf($$,"%s%s",$1,$2);}
-      |  TOK_XOR expr 
-                   {sprintf($$,"%s%s",$1,$2);}
-      |  TOK_OR expr 
-                   {sprintf($$,"%s%s",$1,$2);}
-      |  TOK_AND expr 
-                   {sprintf($$,"%s%s",$1,$2);}
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s%s",$1,$2);}
+      |  '<''=' expr %prec TOK_EQ
+                   {if ( couldaddvariable == 1 ) sprintf($$," <= %s",$3);}
+      |  TOK_NE expr %prec TOK_EQ
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s%s",$1,$2);}
+      |  TOK_XOR expr
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s%s",$1,$2);}
+      |  TOK_OR expr
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s%s",$1,$2);}
+      |  TOK_AND expr
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s%s",$1,$2);}
       |  TOK_SLASH after_slash
-                   {sprintf($$,"%s",$2);}
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s",$2);}
       |  '=' after_equal
-                   {sprintf($$,"%s",$2);}
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s",$2);}
 
 after_slash : {strcpy($$,"");}
-      | expr 
+      | expr
                    {sprintf($$,"/%s",$1);}
-      | '=' expr %prec TOK_EQ 
+      | '=' expr %prec TOK_EQ
                    {sprintf($$,"/= %s",$2);}
       | TOK_SLASH expr
                    {sprintf($$,"//%s",$2);}
       ;
-after_equal : '=' expr %prec TOK_EQ 
-                   {sprintf($$,"==%s",$2);}
+after_equal : '=' expr %prec TOK_EQ
+                   {if ( couldaddvariable == 1 ) sprintf($$,"==%s",$2);}
       | expr
-                   {sprintf($$,"= %s",$1);}
-      ;
-      
-lhs: ident         {strcpy($$,$1);} 
-      | structure_component 
-                   {strcpy($$,$1);} 
-      | array_ele_substring_func_ref 
-                   {strcpy($$,$1);} 
+                   {if ( couldaddvariable == 1 ) sprintf($$,"= %s",$1);}
+      ;
+
+lhs: ident         {if ( couldaddvariable == 1 ) strcpy($$,$1);}
+      | structure_component
+                   {if ( couldaddvariable == 1 ) strcpy($$,$1);}
+      | array_ele_substring_func_ref
+                   {if ( couldaddvariable == 1 ) strcpy($$,$1);}
       ;
 beforefunctionuse : {
@@ -1541,7 +1517,8 @@
                                                             agrif_parentcall =1;
                       if ( Agrif_in_Tok_NAME(identcopy) == 1 )
-                      { 
+                      {
                          inagrifcallargument = 1;
-                         AddsubroutineTolistsubwhereagrifused();
+                         Add_SubroutineWhereAgrifUsed_1(subroutinename,
+                                                        curmodulename);
                       }
                    }
@@ -1552,50 +1529,65 @@
                      if ( incalldeclare == 0 ) inagrifcallargument = 0;
                    }
-      | begin_array substring 
-                   {sprintf($$," %s %s ",$1,$2);}
-      | structure_component '(' funarglist ')' 
-                   {sprintf($$," %s ( %s )",$1,$3);}
-      | structure_component '(' funarglist ')' substring 
-                   {sprintf($$," %s ( %s ) %s ",$1,$3,$5);}
+      | begin_array substring
+                   {if ( couldaddvariable == 1 ) sprintf($$," %s %s ",$1,$2);}
+      | structure_component '(' funarglist ')'
+                   {if ( couldaddvariable == 1 )
+                                                sprintf($$," %s ( %s )",$1,$3);}
+      | structure_component '(' funarglist ')' substring
+                   {if ( couldaddvariable == 1 )
+                                         sprintf($$," %s ( %s ) %s ",$1,$3,$5);}
       ;
 begin_array : ident '(' funarglist ')'
                    {
-                      sprintf($$," %s ( %s )",$1,$3);
-                      ModifyTheAgrifFunction_0($3);
-                     agrif_parentcall =0; 
-                   }
-      ;
-structure_component: lhs '%' lhs 
+                      if ( couldaddvariable == 1 )
+                      {
+                         sprintf($$," %s ( %s )",$1,$3);
+                         ModifyTheAgrifFunction_0($3);
+                         agrif_parentcall =0;
+                      }
+                   }
+      ;
+structure_component: lhs '%' lhs
                    {
                       sprintf($$," %s %% %s ",$1,$3);
-                     if ( incalldeclare == 0 ) inagrifcallargument = 0;
-                   }
-      ;
-vec:  TOK_LEFTAB outlist TOK_RIGHTAB 
-                   {sprintf($$,"(/%s/)",$2);} 
+                      if ( incalldeclare == 0 ) inagrifcallargument = 0;
+                   }
+      ;
+vec:  TOK_LEFTAB outlist TOK_RIGHTAB
+                   {sprintf($$,"(/%s/)",$2);}
       ;
 funarglist: beforefunctionuse    {strcpy($$," ");}
-      | beforefunctionuse funargs  
+      | beforefunctionuse funargs
                    {strcpy($$,$2);}
       ;
-funargs: funarg     {strcpy($$,$1);}
-      | funargs ',' funarg 
-                    {sprintf($$,"%s,%s",$1,$3);} 
+funargs: funarg     {if ( couldaddvariable == 1 ) strcpy($$,$1);}
+      | funargs ',' funarg
+                    {if ( couldaddvariable == 1 ) sprintf($$,"%s,%s",$1,$3);}
       ;
 funarg: expr       {strcpy($$,$1);}
       | triplet    {strcpy($$,$1);}
       ;
-triplet: expr ':' expr 
-                    {sprintf($$,"%s:%s",$1,$3);} 
-      | expr ':' expr ':' expr 
-                    {sprintf($$,"%s:%s:%s",$1,$3,$5);} 
-      | ':' expr ':' expr 
-                    {sprintf($$,":%s:%s",$2,$4);} 
-      | ':' ':' expr{sprintf($$,": : %s",$3);} 
-      | ':' expr    {sprintf($$,":%s",$2);} 
-      | expr ':'     {sprintf($$,"%s:",$1);} 
-      | ':'         {sprintf($$,":");} 
-      ;
-ident : TOK_NAME    {  
+triplet: expr ':' expr
+                    {if ( couldaddvariable == 1 ) sprintf($$,"%s:%s",$1,$3);}
+      | expr ':' expr ':' expr
+                    {if ( couldaddvariable == 1 )
+                                               sprintf($$,"%s:%s:%s",$1,$3,$5);}
+      | ':' expr ':' expr
+                    {if ( couldaddvariable == 1 ) sprintf($$,":%s:%s",$2,$4);}
+      | ':' ':' expr{if ( couldaddvariable == 1 ) sprintf($$,": : %s",$3);}
+      | ':' expr    {if ( couldaddvariable == 1 ) sprintf($$,":%s",$2);}
+      | expr ':'    {if ( couldaddvariable == 1 ) sprintf($$,"%s:",$1);}
+      | ':'         {if ( couldaddvariable == 1 ) sprintf($$,":");}
+      ;
+ident : TOK_NAME    {
+                       if ( couldaddvariable == 1 )
+                       {
+                       if ( Vartonumber($1) == 1 )
+                       {
+                          Add_SubroutineWhereAgrifUsed_1(subroutinename,
+                                                        curmodulename);
+                       }
+                       if (!strcasecmp($1,"Agrif_Parent") )
+                                                            agrif_parentcall =1;
                        if ( VariableIsNotFunction($1) == 0 )
                        {
@@ -1611,6 +1603,5 @@
                           pointedvar=0;
                           if ( VarIsNonGridDepend($1) == 0 &&
-                               formatdeclare == 0 
-                             )
+                               Variableshouldberemove($1) == 0 )
                           {
                              if ( inagrifcallargument == 1 ||
@@ -1620,56 +1611,63 @@
                                 ModifyTheVariableName_0($1);
                              }
-                             if ( inagrifcallargument != 1 || sameagrifargument ==1 )
-                                  ajoutevarindoloop_1($1);
+                             if ( inagrifcallargument != 1 ||
+                                  sameagrifargument ==1 )
+                                  Add_UsedInSubroutine_Var_1($1);
                           }
                           NotifyAgrifFunction_0($1);
                        }
-		    }
-      ;
-simple_const: TOK_TRUE 
-                     {strcpy($$,".TRUE.");}
-      | TOK_FALSE    {strcpy($$,".FALSE.");}
-      | TOK_CSTINT   {strcpy($$,$1);}
-      | TOK_CSTREAL  {strcpy($$,$1);}
-      | TOK_CSTREALDP{strcpy($$,$1);}
-      | TOK_CSTREALQP{strcpy($$,$1);}
-      | simple_const TOK_NAME 
-                     {sprintf($$,"%s%s",$1,$2);}
+                       }
+                    }
+      ;
+simple_const: TOK_TRUE
+                     {if ( couldaddvariable == 1 ) strcpy($$,".TRUE.");}
+      | TOK_FALSE    {if ( couldaddvariable == 1 ) strcpy($$,".FALSE.");}
+      | TOK_CSTINT   {if ( couldaddvariable == 1 ) strcpy($$,$1);}
+      | TOK_CSTREAL  {if ( couldaddvariable == 1 ) strcpy($$,$1);}
+      | TOK_CSTREALDP{if ( couldaddvariable == 1 ) strcpy($$,$1);}
+      | TOK_CSTREALQP{if ( couldaddvariable == 1 ) strcpy($$,$1);}
+      | simple_const TOK_NAME
+                     {if ( couldaddvariable == 1 ) sprintf($$,"%s%s",$1,$2);}
       | string_constant opt_substring
       ;
-string_constant: TOK_CHAR_CONSTANT 
-                     {strcpy($$,$1);}
-      | string_constant TOK_CHAR_CONSTANT 
-      | TOK_CHAR_MESSAGE 
-                     {strcpy($$,$1);}
+string_constant: TOK_CHAR_CONSTANT
+                     {if ( couldaddvariable == 1 ) strcpy($$,$1);}
+      | string_constant TOK_CHAR_CONSTANT
+      | TOK_CHAR_MESSAGE
+                     {if ( couldaddvariable == 1 ) strcpy($$,$1);}
       | TOK_CHAR_CUT
-                     {strcpy($$,$1);}
-      ;
-opt_substring:      {strcpy($$," ");}
-      | substring   {strcpy($$,$1);}
-      ;
-substring: '(' optexpr ':' optexpr ')' 
-                    {sprintf($$,"(%s:%s)",$2,$4);} 
-      ;
-optexpr:           {strcpy($$," ");}
-      | expr        {strcpy($$,$1);}
-      ;
-opt_expr: '\n'          {strcpy($$," ");}
-      | expr        {strcpy($$,$1);}
+                     {if ( couldaddvariable == 1 ) strcpy($$,$1);}
+      ;
+opt_substring:      {if ( couldaddvariable == 1 ) strcpy($$," ");}
+      | substring   {if ( couldaddvariable == 1 ) strcpy($$,$1);}
+      ;
+substring: '(' optexpr ':' optexpr ')'
+                    {if ( couldaddvariable == 1 ) sprintf($$,"(%s:%s)",$2,$4);}
+      ;
+optexpr:           {if ( couldaddvariable == 1 ) strcpy($$," ");}
+      | expr        {if ( couldaddvariable == 1 ) strcpy($$,$1);}
+      ;
+opt_expr: '\n'          {if ( couldaddvariable == 1 ) strcpy($$," ");}
+      | expr        {if ( couldaddvariable == 1 ) strcpy($$,$1);}
       ;
 initial_value:      {InitialValueGiven = 0;}
-      | before_initial '=' expr    
+      | before_initial '=' expr
                     {
-                       strcpy(InitValue,$3);
-                       InitialValueGiven = 1;
-                    } 
+                       if ( couldaddvariable == 1 )
+                       {
+                          strcpy(InitValue,$3);
+                          InitialValueGiven = 1;
+                       }
+                    }
       ;
 before_initial : {pos_curinit = setposcur();}
       ;
-complex_const: '(' uexpr ',' uexpr ')' 
-                    {sprintf($$,"(%s,%s)",$2,$4);} 
+complex_const: '(' uexpr ',' uexpr ')'
+                    {sprintf($$,"(%s,%s)",$2,$4);}
       ;
 use_stat: word_use  module_name
                     {
+                      if ( couldaddvariable == 1 )
+                      {
                       /* if variables has been declared in a subroutine       */
                       if (insubroutinedeclare == 1)
@@ -1678,5 +1676,5 @@
                       }
                       sprintf(charusemodule,"%s",$2);
-                      Addmoduletothelist_1($2);
+                      Add_NameOfModuleUsed_1($2);
 
                       if ( inmoduledeclare == 0 )
@@ -1686,12 +1684,15 @@
                                                pos_end-pos_curuse);
                       }
-                    }    
+                      }
+                    }
       | word_use  module_name ',' rename_list
                     {
+                       if ( couldaddvariable == 1 )
+                       {
                       if (insubroutinedeclare == 1)
                       {
-                         completelistvarpointtovar_1($2,$4);
-                      }
-                      if ( firstpass == 1 ) 
+                         Add_CouplePointed_Var_1($2,$4);
+                      }
+                      if ( firstpass == 1 )
                       {
                          if ( insubroutinedeclare == 1 )
@@ -1701,7 +1702,7 @@
                             while ( coupletmp )
                             {
-                               strcat(ligne,coupletmp->namevar);
+                               strcat(ligne,coupletmp->c_namevar);
                                strcat(ligne," => ");
-                               strcat(ligne,coupletmp->namepointedvar);
+                               strcat(ligne,coupletmp->c_namepointedvar);
                                coupletmp = coupletmp->suiv;
                                if ( coupletmp ) strcat(ligne,",");
@@ -1709,5 +1710,5 @@
                             sprintf(charusemodule,"%s",$2);
                          }
-                         Addmoduletothelist_1($2);
+                         Add_NameOfModuleUsed_1($2);
                       }
                       if ( inmoduledeclare == 0 )
@@ -1717,7 +1718,10 @@
                                                pos_end-pos_curuse);
                       }
-                    }    
+                      }
+                    }
       | word_use  module_name ',' TOK_ONLY ':' '\n'
                     {
+                       if ( couldaddvariable == 1 )
+                       {
                       /* if variables has been declared in a subroutine       */
                       if (insubroutinedeclare == 1)
@@ -1726,5 +1730,5 @@
                       }
                       sprintf(charusemodule,"%s",$2);
-                      Addmoduletothelist_1($2);
+                      Add_NameOfModuleUsed_1($2);
 
                        if ( inmoduledeclare == 0 )
@@ -1734,13 +1738,16 @@
                                                 pos_end-pos_curuse);
                        }
-                    }    
+                       }
+                    }
       | word_use  module_name ',' TOK_ONLY ':' only_list
                     {
+                       if ( couldaddvariable == 1 )
+                       {
                        /* if variables has been declared in a subroutine      */
                        if (insubroutinedeclare == 1)
                        {
-                          completelistvarpointtovar_1($2,$6);
+                          Add_CouplePointed_Var_1($2,$6);
                        }
-                       if ( firstpass == 1 ) 
+                       if ( firstpass == 1 )
                        {
                          if ( insubroutinedeclare == 1 )
@@ -1750,8 +1757,8 @@
                              while ( coupletmp )
                              {
-                                strcat(ligne,coupletmp->namevar);
-                                if ( strcasecmp(coupletmp->namepointedvar,"") )
+                                strcat(ligne,coupletmp->c_namevar);
+                               if ( strcasecmp(coupletmp->c_namepointedvar,"") )
                                                            strcat(ligne," => ");
-                                strcat(ligne,coupletmp->namepointedvar);
+                                strcat(ligne,coupletmp->c_namepointedvar);
                                 coupletmp = coupletmp->suiv;
                                 if ( coupletmp ) strcat(ligne,",");
@@ -1759,8 +1766,8 @@
                              sprintf(charusemodule,"%s",$2);
                           }
-                          Addmoduletothelist_1($2);
+                          Add_NameOfModuleUsed_1($2);
                        }
                        if ( firstpass == 0 )
-		       {
+                       {
                           if ( inmoduledeclare == 0 )
                           {
@@ -1769,12 +1776,13 @@
                                                    pos_end-pos_curuse);
                           }
-		          else
-		          {
-   		             /* if we are in the module declare and if the    */
-	   	             /* onlylist is a list of global variable         */
-		             variableisglobalinmodule($6, $2, fortranout);
-		          }
+                          else
+                          {
+                             /* if we are in the module declare and if the    */
+                             /* onlylist is a list of global variable         */
+                             variableisglobalinmodule($6, $2, fortranout);
+                          }
                        }
-                    }    
+                       }
+                    }
       ;
 word_use : TOK_USE
@@ -1783,16 +1791,19 @@
                    }
       ;
-module_name: TOK_NAME 
+module_name: TOK_NAME
                     {strcpy($$,$1);}
       ;
 rename_list: rename_name
                     {
-                       $$ = $1;
-                    }                    
+                       if ( couldaddvariable == 1 ) $$ = $1;
+                    }
       | rename_list ',' rename_name
                     {
+                        if ( couldaddvariable == 1 )
+                        {
                         /* insert the variable in the list $1                 */
                         $3->suiv = $1;
                         $$ = $3;
+                        }
                     }
       ;
@@ -1800,35 +1811,38 @@
                     {
                        coupletmp =(listcouple *)malloc(sizeof(listcouple));
-                       strcpy(coupletmp->namevar,$1);
-                       strcpy(coupletmp->namepointedvar,$3);
+                       strcpy(coupletmp->c_namevar,$1);
+                       strcpy(coupletmp->c_namepointedvar,$3);
                        coupletmp->suiv = NULL;
                        $$ = coupletmp;
                      }
       ;
-only_list: only_name 
+only_list: only_name
                     {
-                       $$ = $1;
-                    }                    
+                       if ( couldaddvariable == 1 ) $$ = $1;
+                    }
       | only_list ',' only_name
                     {
+                        if ( couldaddvariable == 1 )
+                        {
                         /* insert the variable in the list $1                 */
                         $3->suiv = $1;
                         $$ = $3;
+                        }
                     }
       ;
-only_name: TOK_NAME TOK_POINT_TO TOK_NAME 
+only_name: TOK_NAME TOK_POINT_TO TOK_NAME
                     {
                        coupletmp =(listcouple *)malloc(sizeof(listcouple));
-                       strcpy(coupletmp->namevar,$1);
-                       strcpy(coupletmp->namepointedvar,$3);
+                       strcpy(coupletmp->c_namevar,$1);
+                       strcpy(coupletmp->c_namepointedvar,$3);
                        coupletmp->suiv = NULL;
                        $$ = coupletmp;
                        pointedvar=1;
-                       ajoutevarindoloop_1($1);
+                       Add_UsedInSubroutine_Var_1($1);
                     }
       | TOK_NAME    {
                        coupletmp =(listcouple *)malloc(sizeof(listcouple));
-                       strcpy(coupletmp->namevar,$1);
-                       strcpy(coupletmp->namepointedvar,"");
+                       strcpy(coupletmp->c_namevar,$1);
+                       strcpy(coupletmp->c_namepointedvar,"");
                        coupletmp->suiv = NULL;
                        $$ = coupletmp;
@@ -1837,8 +1851,28 @@
 exec: iffable
       | TOK_ALLOCATE '(' allocation_list opt_stat_spec ')'
+                     {
+                         Add_SubroutineWhereAgrifUsed_1(subroutinename,
+                                                        curmodulename);
+                     }
       | TOK_DEALLOCATE '(' allocate_object_list opt_stat_spec ')'
+                     {
+                          Add_SubroutineWhereAgrifUsed_1(subroutinename,
+                                                         curmodulename);
+                     }
       | TOK_NULLIFY '(' pointer_name_list ')'
-      | TOK_ENDUNIT /* end                                                    */
+      | word_endunit /* end                                                   */
                     {
+                       GlobalDeclaration = 0 ;
+                       if ( firstpass == 0 &&
+                            strcasecmp(subroutinename,"") )
+                       {
+                          if ( module_declar && insubroutinedeclare == 0 )
+                          {
+                              fclose(module_declar);
+                          }
+                       }
+                       if ( couldaddvariable == 1 &&
+                            strcasecmp(subroutinename,"") )
+                       {
                        if ( inmodulemeet == 1 )
                        {
